package com.ora.client;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.imageio.spi.ServiceRegistry;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Das Bootstrap Servlet der Anwendung und gleichzeitig das FrontController
 * Servlet.
 * 
 * Das Servlet leitet eingehende Anfragen an eine Helperklasse weiter, die
 * gleichzeitig ein Komoponente im Sinne der DI des Launcher darstellt.
 * 
 * @see FrontControllerBuddy
 */
public final class ORATestServlet extends HttpServlet {

	
	private List<IService> serviceList = new LinkedList<IService>();
	
	@Override
	public void init() throws ServletException {
		super.init();
		Iterator<IService> iter = ServiceRegistry.lookupProviders(IService.class);
		while (iter.hasNext()) {
			this.serviceList.add(iter.next());
		}
	}

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		PrintWriter out = resp.getWriter();
		
		for (IService service : this.serviceList) {
			out.write("\n<br>");
			service.write(out);
		}

	}
}